diff --git a/base/server/python/pki/server/deployment/pkihelper.py b/base/server/python/pki/server/deployment/pkihelper.py
index 9257cbf..033ff29 100644
--- a/base/server/python/pki/server/deployment/pkihelper.py
+++ b/base/server/python/pki/server/deployment/pkihelper.py
@@ -769,16 +803,386 @@ class ConfigurationFile:
                             "pki_external_ca_cert_path",
                             self.master_dict['pki_user_deployment_cfg'],
                             extra=config.PKI_INDENTATION_LEVEL_2)
-                        raise Exception(log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 % ("pki_extrenal_ca_cert_path",
-                                                                                              self.master_dict['pki_user_deployment_cfg']))
-                    elif os.path.exists(self.master_dict['pki_external_ca_cert_path']) and\
+                        raise Exception(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 %
+                                ("pki_external_ca_cert_path",
+                                 self.master_dict['pki_user_deployment_cfg']))
+                    elif not os.path.exists(self.master_dict['pki_external_ca_cert_path']) or\
                          not os.path.isfile(
                                  self.master_dict['pki_external_ca_cert_path']):
                         config.pki_log.error(
-                            log.PKI_FILE_ALREADY_EXISTS_NOT_A_FILE_1,
+                            log.PKI_FILE_MISSING_OR_NOT_A_FILE_1,
                             self.master_dict['pki_external_ca_cert_path'],
                             extra=config.PKI_INDENTATION_LEVEL_2)
-                        raise Exception(log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 % "pki_extrenal_ca_cert_path")
+                        raise Exception(log.PKI_FILE_MISSING_OR_NOT_A_FILE_1 %
+                                        "pki_external_ca_cert_path")
+            elif not config.str2bool(self.master_dict['pki_skip_configuration']) and\
+                 ((self.master_dict['pki_subsystem'] == "KRA" or
+                   self.master_dict['pki_subsystem'] == "OCSP") and
+                  config.str2bool(self.master_dict['pki_standalone'])):
+                if not self.master_dict.has_key('pki_external_step_two') or\
+                   not len(self.master_dict['pki_external_step_two']):
+                    config.pki_log.error(
+                        log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                        "pki_external_step_two",
+                        self.master_dict['pki_user_deployment_cfg'],
+                        extra=config.PKI_INDENTATION_LEVEL_2)
+                    raise Exception(
+                        log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 %
+                            ("pki_external_step_two",
+                             self.master_dict['pki_user_deployment_cfg']))
+                if not config.str2bool(self.master_dict['pki_external_step_two']):
+                    # Stand-alone PKI KRA/OCSP Admin CSR
+                    # (External CA Step 1)
+                    if not self.master_dict.has_key('pki_external_admin_csr_path') or\
+                       not len(self.master_dict['pki_external_admin_csr_path']):
+                        config.pki_log.error(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                            "pki_external_admin_csr_path",
+                            self.master_dict['pki_user_deployment_cfg'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        raise Exception(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 %
+                                ("pki_external_admin_csr_path",
+                                 self.master_dict['pki_user_deployment_cfg']))
+                    elif os.path.exists(self.master_dict['pki_external_admin_csr_path']):
+                        config.pki_log.error(
+                            log.PKI_FILE_ALREADY_EXISTS_1,
+                            self.master_dict['pki_external_admin_csr_path'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        raise Exception(log.PKI_FILE_ALREADY_EXISTS_1 %
+                                        "pki_external_admin_csr_path")
+                    # Stand-alone PKI KRA/OCSP Audit Signing CSR
+                    # (External CA Step 1)
+                    if not self.master_dict.has_key('pki_external_audit_signing_csr_path') or\
+                       not len(self.master_dict['pki_external_audit_signing_csr_path']):
+                        config.pki_log.error(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                            "pki_external_audit_signing_csr_path",
+                            self.master_dict['pki_user_deployment_cfg'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        raise Exception(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 %
+                                ("pki_external_audit_signing_csr_path",
+                                 self.master_dict['pki_user_deployment_cfg']))
+                    elif os.path.exists(self.master_dict['pki_external_audit_signing_csr_path']):
+                        config.pki_log.error(
+                            log.PKI_FILE_ALREADY_EXISTS_1,
+                            self.master_dict['pki_external_audit_signing_csr_path'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        raise Exception(log.PKI_FILE_ALREADY_EXISTS_1 %
+                                        "pki_external_audit_signing_csr_path")
+                    # Stand-alone PKI KRA/OCSP SSL Server CSR
+                    # (External CA Step 1)
+                    if not self.master_dict.has_key('pki_external_sslserver_csr_path') or\
+                       not len(self.master_dict['pki_external_sslserver_csr_path']):
+                        config.pki_log.error(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                            "pki_external_sslserver_csr_path",
+                            self.master_dict['pki_user_deployment_cfg'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        raise Exception(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 %
+                                ("pki_external_sslserver_csr_path",
+                                 self.master_dict['pki_user_deployment_cfg']))
+                    elif os.path.exists(self.master_dict['pki_external_sslserver_csr_path']):
+                        config.pki_log.error(
+                            log.PKI_FILE_ALREADY_EXISTS_1,
+                            self.master_dict['pki_external_sslserver_csr_path'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        raise Exception(log.PKI_FILE_ALREADY_EXISTS_1 %
+                                        "pki_external_sslserver_csr_path")
+                    # Stand-alone PKI KRA/OCSP Subsystem CSR
+                    # (External CA Step 1)
+                    if not self.master_dict.has_key('pki_external_subsystem_csr_path') or\
+                       not len(self.master_dict['pki_external_subsystem_csr_path']):
+                        config.pki_log.error(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                            "pki_external_subsystem_csr_path",
+                            self.master_dict['pki_user_deployment_cfg'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        raise Exception(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 %
+                                ("pki_external_subsystem_csr_path",
+                                 self.master_dict['pki_user_deployment_cfg']))
+                    elif os.path.exists(self.master_dict['pki_external_subsystem_csr_path']):
+                        config.pki_log.error(
+                            log.PKI_FILE_ALREADY_EXISTS_1,
+                            self.master_dict['pki_external_subsystem_csr_path'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        raise Exception(log.PKI_FILE_ALREADY_EXISTS_1 %
+                                        "pki_external_subsystem_csr_path")
+                    # Stand-alone PKI KRA CSRs
+                    if self.master_dict['pki_subsystem'] == "KRA":
+                        # Stand-alone PKI KRA Storage CSR
+                        # (External CA Step 1)
+                        if not self.master_dict.has_key('pki_external_storage_csr_path') or\
+                           not len(self.master_dict['pki_external_storage_csr_path']):
+                            config.pki_log.error(
+                                log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                                "pki_external_storage_csr_path",
+                                self.master_dict['pki_user_deployment_cfg'],
+                                extra=config.PKI_INDENTATION_LEVEL_2)
+                            raise Exception(
+                                log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 %
+                                    ("pki_external_storage_csr_path",
+                                     self.master_dict['pki_user_deployment_cfg']))
+                        elif os.path.exists(self.master_dict['pki_external_storage_csr_path']):
+                            config.pki_log.error(
+                                log.PKI_FILE_ALREADY_EXISTS_1,
+                                self.master_dict['pki_external_storage_csr_path'],
+                                extra=config.PKI_INDENTATION_LEVEL_2)
+                            raise Exception(log.PKI_FILE_ALREADY_EXISTS_1 %
+                                            "pki_external_storage_csr_path")
+                        # Stand-alone PKI KRA Transport CSR
+                        # (External CA Step 1)
+                        if not self.master_dict.has_key('pki_external_transport_csr_path') or\
+                           not len(self.master_dict['pki_external_transport_csr_path']):
+                            config.pki_log.error(
+                                log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                                "pki_external_transport_csr_path",
+                                self.master_dict['pki_user_deployment_cfg'],
+                                extra=config.PKI_INDENTATION_LEVEL_2)
+                            raise Exception(
+                                log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 %
+                                    ("pki_external_transport_csr_path",
+                                     self.master_dict['pki_user_deployment_cfg']))
+                        elif os.path.exists(self.master_dict['pki_external_transport_csr_path']):
+                            config.pki_log.error(
+                                log.PKI_FILE_ALREADY_EXISTS_1,
+                                self.master_dict['pki_external_transport_csr_path'],
+                                extra=config.PKI_INDENTATION_LEVEL_2)
+                            raise Exception(log.PKI_FILE_ALREADY_EXISTS_1 %
+                                            "pki_external_transport_csr_path")
+                    # Stand-alone PKI OCSP CSRs
+                    if self.master_dict['pki_subsystem'] == "OCSP":
+                        # Stand-alone PKI OCSP OCSP Signing CSR
+                        # (External CA Step 1)
+                        if not self.master_dict.has_key('pki_external_signing_csr_path') or\
+                           not len(self.master_dict['pki_external_signing_csr_path']):
+                            config.pki_log.error(
+                                log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                                "pki_external_signing_csr_path",
+                                self.master_dict['pki_user_deployment_cfg'],
+                                extra=config.PKI_INDENTATION_LEVEL_2)
+                            raise Exception(
+                                log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 %
+                                    ("pki_external_signing_csr_path",
+                                     self.master_dict['pki_user_deployment_cfg']))
+                        elif os.path.exists(self.master_dict['pki_external_signing_csr_path']):
+                            config.pki_log.error(
+                                log.PKI_FILE_ALREADY_EXISTS_1,
+                                self.master_dict['pki_external_signing_csr_path'],
+                                extra=config.PKI_INDENTATION_LEVEL_2)
+                            raise Exception(log.PKI_FILE_ALREADY_EXISTS_1 %
+                                            "pki_external_signing_csr_path")
+                else:
+                    # Stand-alone PKI KRA/OCSP External CA Certificate Chain
+                    # (External CA Step 2)
+                    if not self.master_dict.has_key('pki_external_ca_cert_chain_path') or\
+                       not len(self.master_dict['pki_external_ca_cert_chain_path']):
+                        config.pki_log.error(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                            "pki_external_ca_cert_chain_path",
+                            self.master_dict['pki_user_deployment_cfg'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        raise Exception(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 %
+                                ("pki_external_ca_cert_chain_path",
+                                 self.master_dict['pki_user_deployment_cfg']))
+                    elif not os.path.exists(
+                                 self.master_dict['pki_external_ca_cert_chain_path']) or\
+                         not os.path.isfile(
+                                 self.master_dict['pki_external_ca_cert_chain_path']):
+                        config.pki_log.error(
+                            log.PKI_FILE_MISSING_OR_NOT_A_FILE_1,
+                            self.master_dict['pki_external_ca_cert_chain_path'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        raise Exception(log.PKI_FILE_MISSING_OR_NOT_A_FILE_1 %
+                                        "pki_external_ca_cert_chain_path")
+                    # Stand-alone PKI KRA/OCSP External CA Certificate
+                    # (External CA Step 2)
+                    if not self.master_dict.has_key('pki_external_ca_cert_path') or\
+                       not len(self.master_dict['pki_external_ca_cert_path']):
+                        config.pki_log.error(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                            "pki_external_ca_cert_path",
+                            self.master_dict['pki_user_deployment_cfg'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        raise Exception(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 %
+                                ("pki_external_ca_cert_path",
+                                 self.master_dict['pki_user_deployment_cfg']))
+                    elif not os.path.exists(self.master_dict['pki_external_ca_cert_path']) or\
+                         not os.path.isfile(
+                                 self.master_dict['pki_external_ca_cert_path']):
+                        config.pki_log.error(
+                            log.PKI_FILE_MISSING_OR_NOT_A_FILE_1,
+                            self.master_dict['pki_external_ca_cert_path'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        raise Exception(log.PKI_FILE_MISSING_OR_NOT_A_FILE_1 %
+                                        "pki_external_ca_cert_path")
+                    # Stand-alone PKI KRA/OCSP Admin Certificate
+                    # (External CA Step 2)
+                    if not self.master_dict.has_key('pki_external_admin_cert_path') or\
+                       not len(self.master_dict['pki_external_admin_cert_path']):
+                        config.pki_log.error(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                            "pki_external_admin_cert_path",
+                            self.master_dict['pki_user_deployment_cfg'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        raise Exception(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 %
+                                ("pki_external_admin_cert_path",
+                                 self.master_dict['pki_user_deployment_cfg']))
+                    elif not os.path.exists(self.master_dict['pki_external_admin_cert_path']) or\
+                         not os.path.isfile(
+                                 self.master_dict['pki_external_admin_cert_path']):
+                        config.pki_log.error(
+                            log.PKI_FILE_MISSING_OR_NOT_A_FILE_1,
+                            self.master_dict['pki_external_admin_cert_path'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        raise Exception(log.PKI_FILE_MISSING_OR_NOT_A_FILE_1 %
+                                        "pki_external_admin_cert_path")
+                    # Stand-alone PKI KRA/OCSP Audit Signing Certificate
+                    # (External CA Step 2)
+                    if not self.master_dict.has_key('pki_external_audit_signing_cert_path') or\
+                       not len(self.master_dict['pki_external_audit_signing_cert_path']):
+                        config.pki_log.error(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                            "pki_external_audit_signing_cert_path",
+                            self.master_dict['pki_user_deployment_cfg'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        raise Exception(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 %
+                                ("pki_external_audit_signing_cert_path",
+                                 self.master_dict['pki_user_deployment_cfg']))
+                    elif not os.path.exists(self.master_dict['pki_external_audit_signing_cert_path']) or\
+                         not os.path.isfile(
+                                 self.master_dict['pki_external_audit_signing_cert_path']):
+                        config.pki_log.error(
+                            log.PKI_FILE_MISSING_OR_NOT_A_FILE_1,
+                            self.master_dict['pki_external_audit_signing_cert_path'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        raise Exception(log.PKI_FILE_MISSING_OR_NOT_A_FILE_1 %
+                                        "pki_external_audit_signing_cert_path")
+                    # Stand-alone PKI KRA/OCSP SSL Server Certificate
+                    # (External CA Step 2)
+                    if not self.master_dict.has_key('pki_external_sslserver_cert_path') or\
+                       not len(self.master_dict['pki_external_sslserver_cert_path']):
+                        config.pki_log.error(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                            "pki_external_sslserver_cert_path",
+                            self.master_dict['pki_user_deployment_cfg'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        raise Exception(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 %
+                                ("pki_external_sslserver_cert_path",
+                                 self.master_dict['pki_user_deployment_cfg']))
+                    elif not os.path.exists(self.master_dict['pki_external_sslserver_cert_path']) or\
+                         not os.path.isfile(
+                                 self.master_dict['pki_external_sslserver_cert_path']):
+                        config.pki_log.error(
+                            log.PKI_FILE_MISSING_OR_NOT_A_FILE_1,
+                            self.master_dict['pki_external_sslserver_cert_path'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        raise Exception(log.PKI_FILE_MISSING_OR_NOT_A_FILE_1 %
+                                        "pki_external_sslserver_cert_path")
+                    # Stand-alone PKI KRA/OCSP Subsystem Certificate
+                    # (External CA Step 2)
+                    if not self.master_dict.has_key('pki_external_subsystem_cert_path') or\
+                       not len(self.master_dict['pki_external_subsystem_cert_path']):
+                        config.pki_log.error(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                            "pki_external_subsystem_cert_path",
+                            self.master_dict['pki_user_deployment_cfg'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        raise Exception(
+                            log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 %
+                                ("pki_external_subsystem_cert_path",
+                                 self.master_dict['pki_user_deployment_cfg']))
+                    elif not os.path.exists(self.master_dict['pki_external_subsystem_cert_path']) or\
+                         not os.path.isfile(
+                                 self.master_dict['pki_external_subsystem_cert_path']):
+                        config.pki_log.error(
+                            log.PKI_FILE_MISSING_OR_NOT_A_FILE_1,
+                            self.master_dict['pki_external_subsystem_cert_path'],
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        raise Exception(log.PKI_FILE_MISSING_OR_NOT_A_FILE_1 %
+                                        "pki_external_subsystem_cert_path")
+                    # Stand-alone PKI KRA Certificates
+                    if self.master_dict['pki_subsystem'] == "KRA":
+                        # Stand-alone PKI KRA Storage Certificate
+                        # (External CA Step 2)
+                        if not self.master_dict.has_key('pki_external_storage_cert_path') or\
+                           not len(self.master_dict['pki_external_storage_cert_path']):
+                            config.pki_log.error(
+                                log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                                "pki_external_storage_cert_path",
+                                self.master_dict['pki_user_deployment_cfg'],
+                                extra=config.PKI_INDENTATION_LEVEL_2)
+                            raise Exception(
+                                log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 %
+                                    ("pki_external_storage_cert_path",
+                                     self.master_dict['pki_user_deployment_cfg']))
+                        elif not os.path.exists(self.master_dict['pki_external_storage_cert_path']) or\
+                             not os.path.isfile(
+                                     self.master_dict['pki_external_storage_cert_path']):
+                            config.pki_log.error(
+                                log.PKI_FILE_MISSING_OR_NOT_A_FILE_1,
+                                self.master_dict['pki_external_storage_cert_path'],
+                                extra=config.PKI_INDENTATION_LEVEL_2)
+                            raise Exception(
+                                    log.PKI_FILE_MISSING_OR_NOT_A_FILE_1 %
+                                    "pki_external_storage_cert_path")
+                        # Stand-alone PKI KRA Transport Certificate
+                        # (External CA Step 2)
+                        if not self.master_dict.has_key('pki_external_transport_cert_path') or\
+                           not len(self.master_dict['pki_external_transport_cert_path']):
+                            config.pki_log.error(
+                                log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                                "pki_external_transport_cert_path",
+                                self.master_dict['pki_user_deployment_cfg'],
+                                extra=config.PKI_INDENTATION_LEVEL_2)
+                            raise Exception(
+                                log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 %
+                                    ("pki_external_transport_cert_path",
+                                     self.master_dict['pki_user_deployment_cfg']))
+                        elif not os.path.exists(self.master_dict['pki_external_transport_cert_path']) or\
+                             not os.path.isfile(
+                                     self.master_dict['pki_external_transport_cert_path']):
+                            config.pki_log.error(
+                                log.PKI_FILE_MISSING_OR_NOT_A_FILE_1,
+                                self.master_dict['pki_external_transport_cert_path'],
+                                extra=config.PKI_INDENTATION_LEVEL_2)
+                            raise Exception(
+                                log.PKI_FILE_MISSING_OR_NOT_A_FILE_1 %
+                                    "pki_external_transport_cert_path")
+                    # Stand-alone PKI OCSP Certificates
+                    if self.master_dict['pki_subsystem'] == "OCSP":
+                        # Stand-alone PKI OCSP OCSP Signing Certificate
+                        # (External CA Step 2)
+                        if not self.master_dict.has_key('pki_external_signing_cert_path') or\
+                           not len(self.master_dict['pki_external_signing_cert_path']):
+                            config.pki_log.error(
+                                log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2,
+                                "pki_external_signing_cert_path",
+                                self.master_dict['pki_user_deployment_cfg'],
+                                extra=config.PKI_INDENTATION_LEVEL_2)
+                            raise Exception(
+                                log.PKIHELPER_UNDEFINED_CONFIGURATION_FILE_ENTRY_2 %
+                                    ("pki_external_signing_cert_path",
+                                     self.master_dict['pki_user_deployment_cfg']))
+                        elif not os.path.exists(self.master_dict['pki_external_signing_cert_path']) or\
+                             not os.path.isfile(
+                                     self.master_dict['pki_external_signing_cert_path']):
+                            config.pki_log.error(
+                                log.PKI_FILE_MISSING_OR_NOT_A_FILE_1,
+                                self.master_dict['pki_external_signing_cert_path'],
+                                extra=config.PKI_INDENTATION_LEVEL_2)
+                            raise Exception(
+                                log.PKI_FILE_MISSING_OR_NOT_A_FILE_1 %
+                                    "pki_external_signing_cert_path")
         return
 
     def populate_non_default_ports(self):
